<p>In the previous section, we spent some time (and some of our hard-earned trust points within the project!), trying to get a recommendation for a good first issue to solve, beyond our initial micro-contributions. Those were extremely small, but were valuable to build the base experience we'll rely on now, to try to push a more significant change.</p>
<div class="flex-container">
<div class="figure-and-caption"><img height="300" width="300" src="/static/mod5-small_bug_with_checkmark.svg" alt="small ladybug holding up a big checkmark" /></div>
<div class="side-text">
<h3>Keep it small, still!</h3>
<p>Note however that this first issue must remain <strong>small</strong>. Maybe not as small as fixing a typo in the documentation, but it should remain very small still! It would be useful to try our hand at fixing an actual bug, to start making "real" code changes -- but we still want something that won't require too much development time, or too much context. We are still using this step to learn our way through the project, and start getting a feel for the code base as well as the type of review comments you'll get on code changes. But we don't want to have to be writing a torrent of new code for days or weeks -- we just don't know the project well enough for that.</p>
</div>
</div>
<p>At the beginning, chances are we will have to rewrite your code to pass the review -- sometimes multiple times. Do yourself a favor and keep it small! You'll be less tempted to resist review comments from upstream this way, and end up with less work on each iteration.</p>
<p>Over time, we'll build the experience and confidence to try our hand a bigger issues or features - but even then, it's a good idea to keep approaching it through small iterations, checking along the way that we are going in a direction that's acceptable to upstream.</p>
<h3>Picking the issue</h3>
<p>If we have received suggestions in response to our request for a good first issue, great! We still need to try to make sure it's not too big, as often developers who are more experienced with a project will forget how overwhelming anything can be at the beginning. If it's too big, we shouldn't hesitate to ask for something smaller to start, or for ways to split the work in smaller chunks. Still, a direct recommendation is often our best bet -- plus, we want to make sure that the person who replied to us ends up feeling this was useful -- both to ourselves, and to the project, by ending up with an issue they cared about getting fixed.</p>
<p>If we don't get an answer, or if it's not helpful, we will have to pick one ourselves. It can be harder, but hopefully we have already identified some potential candidates in the last module, when we posted the request for a good first issue. Here again, if the project has a list of</p>
<p>You can also have a look at recent comments from the project maintainers, by searching the various communications tools we have identified previously. What do they care about? Where is their attention focused? Did they mention some work that needed to be done, and doesn't sound too hard to do? Again, look for small/easy tasks that you could carve out from the discussions. Then ask about it in the corresponding discussions threads - you might get the attention of people who haven't seen your question on the forum, and they are more likely to answer you in a topic they already follow, discussing work they are already invested in.</p>